﻿// <copyright file="DesktopServiceFactory.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 10-06-2011 All Right Reserved
// </copyright>
// <author>Anuj Varma, www.anujvarma.com</author>
// <date>10-06-2011</date>
// <summary>Class representing a DesktopServiceFactory.cs entity.</summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Services_Architecture.ServicesByFeature;
using Services_Architecture.ServicesByPlatform;

namespace Services_Architecture.ServiceFactory
{
    public class DesktopServiceFactory: IServiceFactory
    {
        private IDictionary<string, object> allservices = new Dictionary<string, object>();

        public DesktopServiceFactory()
        {
            FillServiceDictionary();
        }

        public void CreateAccount()
{
      //  common code – e.g. perform validation

      // Platform specific code – Mobile or Desktop
      // common code again – e.g. Log Error Messages
}
        public T GetService<T>()
        {
            object service = null;
            T returnedService = (T)service;
            string serviceName = typeof(T).FullName;
            if (allservices.TryGetValue(serviceName, out service))
            {
                returnedService = (T)service;
            }

            return returnedService;

        }

        protected void FillServiceDictionary()
        {
            allservices.Add("IAccountService", new DesktopPlatformAccountService());
        }
    }
}
